<template>
  <div class="song-item" v-if="song">
    <div class="cover"><img :src="'https://beatsaver.com/img/' + this.song.id + '.' + this.song.img"/></div>
    <div class="details">
      <div class="beatName">
        <router-link :to="{ 'name': 'detail', 'params': { 'id': this.song.id }}">
          {{decodeValue(song.beatname)}}
        </router-link>
      </div>
      <div class="authorName">{{decodeValue(song.authorName)}}</div>
      <div class="beatText"></div>
      <div class="difficulties">
        <div class="difficulty-tag">{{Math.round(song.beatsPerMinute)}} bpm</div>
        <div class="difficulty-tag" v-for="diff in getDifficulties()">{{diff}}</div>
      </div>
      <div class="social">
        <div><i class="icon-download" title="Downloads" v-if="song.downloads != undefined"></i> {{song.downloads}}</div>
        <div><i class="icon-music" title="Plays" v-if="song.downloads != undefined"></i> {{song.plays}}</div>
        <div><i class="icon-thumbs-up" title="Likes" v-if="song.downloads != undefined"></i> {{song.upvotes}}</div>
        <div class="download">
          <div class="button" title="Like Song" v-on:click="likeSong()"><i class="icon-thumbs-up"></i></div>
          <div class="button" title="Download Song"><a :href="'https://beatsaver.com/dl.php?id=' + this.song.id"><i class="icon-download"></i></a></div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  export default {
    'name': 'Song',
    'props': {
      song: Object
    },
    'methods': {
      'decodeValue': function(input) {
        var e = document.createElement('div');
        e.innerHTML = input;
        return e.childNodes.length === 0 ? "" : e.childNodes[0].nodeValue;
      },
      'getDifficulties': function() {
        if(!this.song.difficultyLevels) return [];
        try {
          this.song.difficultyLevels = JSON.parse(this.song.difficultyLevels);
        } catch {
          console.log('Song.vue: had to parse difficultyLevels content, got json string');
        }
        return this.song.difficultyLevels.map((diff) => {
          return diff.difficulty;
        })
      },
      'likeSong': function() {
        this.$http.get('https://beatsaver.com/vote.php?id='+ this.song.id)
        .then((res) => {
          console.log(res);
        })
        .catch((err) => {
          console.log(err);
        });
      }
    }
  }
</script>

<style scoped>
  .song-item {
    background-image: url("../assets/bg_blurred.jpg");
    background-repeat: no-repeat;
    background-attachment: fixed;
    background-size: cover;

    margin:5px;
    padding:10px;

    display:flex;
    flex-direction: row;

    color:white;
    width: 600px;
    border-radius: 15px;
    overflow:hidden;
  }

  .cover, img {
    width: 160px;
    height: 160px;
    margin-right:5px;
  }

  .details {
    display:flex;
    flex-direction: column;
    flex-grow:1;
    padding: 5px;
    width: 100%;
    overflow:hidden;
  }

  .beatName {
    text-decoration: none;
    color:white;
    font-size: 22px;
    font-weight: bold;
  }

  .beatName a {
    white-space: nowrap;
    text-overflow: ellipsis;
    width: 100%;
    display: block;
    overflow: hidden;
    text-decoration: none;
    color:white;
  }

  .beatName:hover a {
    color:white;
    text-decoration: underline;
  }

  .beatText {
    margin-top:10px;
    margin-bottom:10px;
    font-size: 12px;
    flex-grow:1;
  }

  .difficulties {
    display:flex;
    flex-direction: row;
  }

  .difficulty-tag {
    font-size: 18px;
    color: black;
    background-color:white;
    padding:3px 6px;
    border-radius:3px;
    margin:2px;
  }

  .social {
    display:flex;
    flex-direction: row;
    margin-top:5px;
  }

  .social > div {
    line-height:40px;
    font-size:20px;
    margin-right:10px;
  }

  .social a {
    color: inherit;
    text-decoration: none;
  }

  .download {
    margin-left: auto;
    margin-right: 5px !important;
    position: relative;
    display: flex;
    flex-direction: row;
  }

  .download .button {
    height: 39px;
    width:50px;
    display:flex;
    justify-content:center;
    align-items:center;
  }

</style>
